//----------------------------------------------------------------------------
// Copyright (c) 2015-2016 Fabrice HARROUET (ENIB)
//
// This file is part of GpuElint.
//   http://www.enib.fr/~harrouet/gpuelint.html
//
// GpuElint is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// GpuElint is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with GpuElint.  If not, see <http://www.gnu.org/licenses/>.
//----------------------------------------------------------------------------

#ifndef GPUELINT_CONTEXT_H
#define GPUELINT_CONTEXT_H 1

#include "gpuElint_platform.h"

typedef struct _GpuElintContext
{
bool initDone;
#if defined _WIN32
  DWORD thread;
  HDC hdc;
  HGLRC ctx;
  struct _UglyWglContextPool *wglCtxPool; // FIXME: see implementation
#else
  bool shared;
  pthread_t thread;
  Display *dpy;
  GLXDrawable drawable;
  GLXContext ctx;
  Bool isDirect;
  GLXFBConfig fbConfig;
  int renderType;
  int screen;
#endif
} GpuElintContext;

bool // success
GpuElintContext_init(GpuElintContext *c,
                     const GpuElintContext *shared);

void
GpuElintContext_destroy(GpuElintContext *c);

bool // thread/context mismatch detected
GpuElintContext_mismatch(const GpuElintContext *c);

#endif // GPUELINT_CONTEXT_H

//----------------------------------------------------------------------------
